diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/sys.c
--- a/src/dep/sys.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/dep/sys.c	Sun Oct 27 22:49:29 2013 -0700
@@ -1,4 +1,6 @@
 /*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
  * Copyright (c) 2011      George V. Neville-Neil, Steven Kreuzer,
  *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen,
  *                         National Instruments.
@@ -39,6 +41,8 @@
  *
  */
 
+#include <inttypes.h>
+
 #include "../ptpd.h"
 
 #if defined(linux)
@@ -55,6 +59,9 @@
 /* only C99 has the round function built-in */
 double round (double __x);
 
+/* TODO Yuk */
+extern PtpClock *G_ptpClock;
+extern PtpClock* G_timeBothClock;
 
 /*
  returns a static char * for the representation of time, for debug purposes
@@ -111,9 +118,11 @@
 	/* always print either a space, or the leading "-". This makes the stat files columns-aligned */
 	len += snprintf(&s[len], max_len - len, "%c",
 		isTimeInternalNegative(p)? '-':' ');
+	if (len > max_len) len = max_len;
 
 	len += snprintf(&s[len], max_len - len, "%d.%09d",
 	    abs(p->seconds), abs(p->nanoseconds));
+	if (len > max_len) len = max_len;
 
 	return len;
 }
@@ -170,11 +179,14 @@
 	int len = 0;
 	int i;
 
-	if (info)
+	if (info) {
 		len += snprintf(&s[len], max_len - len, "%s", info);
+		if (len > max_len) len = max_len;
+	}
 
 	for (i = 0; ;) {
 		len += snprintf(&s[len], max_len - len, "%02x", (unsigned char) id[i]);
+		if (len > max_len) len = max_len;
 
 		if (++i >= CLOCK_IDENTITY_LENGTH)
 			break;
@@ -191,19 +203,23 @@
 	int len = 0;
 	int i;
 
-	if (info)
+	if (info) {
 		len += snprintf(&s[len], max_len - len, "%s", info);
+		if (len > max_len) len = max_len;
+	}
 
 	for (i = 0; ;) {
 		/* skip bytes 3 and 4 */
 		if(!((i==3) || (i==4))){
 			len += snprintf(&s[len], max_len - len, "%02x", (unsigned char) id[i]);
+			if (len > max_len) len = max_len;
 
 			if (++i >= CLOCK_IDENTITY_LENGTH)
 				break;
 
 			/* print a separator after each byte except the last one */
 			len += snprintf(&s[len], max_len - len, "%s", ":");
+			if (len > max_len) len = max_len;
 		} else {
 
 			i++;
@@ -226,7 +242,7 @@
 	static struct ether_addr prev_addr;
 	static char buf[BUF_SIZE];
 
-#if defined(linux) || defined(__NetBSD__)
+#if defined(linux) || defined(__NetBSD__) || defined(__sun)
 	if (memcmp(addr->ether_addr_octet, &prev_addr, 
 		  sizeof(struct ether_addr )) != 0) {
 		valid = 0;
@@ -270,7 +286,7 @@
 	for (i = 0, j = 0; i< CLOCK_IDENTITY_LENGTH ; i++ ){
 		/* skip bytes 3 and 4 */
 		if(!((i==3) || (i==4))){
-#if defined(linux) || defined(__NetBSD__)
+#if defined(linux) || defined(__NetBSD__) || defined(__sun)
 			e.ether_addr_octet[j] = (uint8_t) id[i];
 #else // e.g. defined(__FreeBSD__)
 			e.octet[j] = (uint8_t) id[i];
@@ -282,6 +298,7 @@
 	/* convert and print hostname */
 	ether_ntohost_cache(buf, &e);
 	len += snprintf(&s[len], max_len - len, "(%s)", buf);
+	if (len > max_len) len = max_len;
 
 	return len;
 }
@@ -292,18 +309,23 @@
 {
 	int len = 0;
 
-	if (info)
+	if (info) {
 		len += snprintf(&s[len], max_len - len, "%s", info);
+		if (len > max_len) len = max_len;
+	}
 
 #ifdef PRINT_MAC_ADDRESSES
 	len += snprint_ClockIdentity_mac(&s[len], max_len - len, id->clockIdentity, NULL);
 #else	
 	len += snprint_ClockIdentity(&s[len], max_len - len, id->clockIdentity, NULL);
 #endif
+	if (len > max_len) len = max_len;
 
 	len += snprint_ClockIdentity_ntohost(&s[len], max_len - len, id->clockIdentity, NULL);
+	if (len > max_len) len = max_len;
 
 	len += snprintf(&s[len], max_len - len, "/%02x", (unsigned) id->portNumber);
+	if (len > max_len) len = max_len;
 	return len;
 }
 
@@ -356,7 +378,6 @@
 		struct timeval now;
 
 		extern char *translatePortState(PtpClock *ptpClock);
-		extern PtpClock *G_ptpClock;
 
 		fprintf(stderr, "   (ptpd %-9s ",
 			priority == LOG_EMERG   ? "emergency)" :
@@ -387,7 +408,51 @@
 	va_end(ap);
 }
 
-void 
+/*
+* Dumps a data buffer
+* This either prints the message to syslog, or with timestamp+state to stderr 
+* (which has possibly been redirected to a file, using logtofile()/dup2()
+*/
+void
+dump(const char *text, void *addr, int len)
+{
+  uint8_t *address = (uint8_t *)addr;
+  extern RunTimeOpts rtOpts;
+  if(rtOpts.useSysLog) {
+    int i;
+    static Boolean logOpened;
+    if(!logOpened) {
+      openlog("ptpd2", 0, LOG_DAEMON);
+      logOpened = TRUE;
+    }
+
+    syslog(LOG_DEBUG, "%s: length %d, data...\n", text, len);
+    for (i = 0; i < len; i++) {
+      syslog(LOG_DEBUG, "0x%02x ", address[i]);
+      if ((i % 8) == 7) {
+        syslog(LOG_DEBUG, "\n");
+      }
+    }
+    if ((i % 8) != 0) {
+      syslog(LOG_DEBUG, "\n");
+    }
+
+  } else {
+    int i;
+    fprintf(stderr, "%s: length %d, data...\n", text, len);
+    for (i = 0; i < len; i++) {
+      fprintf(stderr, "0x%02x ", address[i]);
+      if ((i % 8) == 7) {
+        fprintf(stderr, "\n");
+      }
+    }
+    if ((i % 8) != 0) {
+      fprintf(stderr, "\n");
+    }
+  }
+}
+
+void
 displayStats(RunTimeOpts * rtOpts, PtpClock * ptpClock)
 {
 	static int start = 1;
@@ -402,6 +467,14 @@
 		return;
 	}
 
+  /* In non-verbose mode, don't print a separate line for the other ptp clock
+   * instance used for time both if we've in slave state. Conversely, if in 
+   * listening or master state we do want stats, even if this is non-verbose mode
+   */
+  if (!rtOpts->verboseStats && (ptpClock != G_ptpClock) &&
+	(G_ptpClock->portState == PTP_SLAVE)) {
+	return;
+  }
 
 	
 	if (start && rtOpts->csvStats) {
@@ -413,7 +486,7 @@
 	}
 	memset(sbuf, ' ', sizeof(sbuf));
 
-	getTime(&now);
+	getTime(&now, TIME_SYSTEM, ptpClock);
 
 
 	/*
@@ -440,110 +513,167 @@
 	strftime(time_str, MAXTIMESTR, "%Y-%m-%d %X", localtime(&time_s));
 	len += snprintf(sbuf + len, sizeof(sbuf) - len, "%s%s.%06d, %s",
 		       rtOpts->csvStats ? "" : "state: ",
-		       time_str, (int)now.nanoseconds/1000,
+			time_str, (int)now.nanoseconds/1000,
 		       translatePortState(ptpClock));
+	if (len > sizeof(sbuf)) len = sizeof(sbuf);
+
+	if (ptpClock->name != NULL) {
+		len += snprintf(sbuf + len, sizeof(sbuf) - len, "%s ", ptpClock->name);
+		if (len > sizeof(sbuf)) len = sizeof(sbuf);
+	}
+
+	if (rtOpts->verboseStats) {
+		len += snprintf(sbuf + len, sizeof(sbuf) - len, "%s, ",
+			translatePortState(ptpClock));
+		if (len > sizeof(sbuf)) len = sizeof(sbuf);
+	}
 
 	if (ptpClock->portState == PTP_SLAVE) {
-		len += snprint_PortIdentity(sbuf + len, sizeof(sbuf) - len,
-			 &ptpClock->parentPortIdentity, " ");
+		if (!rtOpts->verboseStats) {
+			int64_t offset = ((int64_t)ptpClock->offsetFromMaster.seconds * 1000000000)
+				+ (int64_t)ptpClock->offsetFromMaster.nanoseconds;
 
-		/* 
-		 * if grandmaster ID differs from parent port ID then
-		 * also print GM ID 
-		 */
-		if (memcmp(ptpClock->grandmasterIdentity, 
-			   ptpClock->parentPortIdentity.clockIdentity, 
-			   CLOCK_IDENTITY_LENGTH)) {
-			len += snprint_ClockIdentity(sbuf + len, 
-						     sizeof(sbuf) - len,
-						     ptpClock->grandmasterIdentity, 
-						     " GM:");
-		}
+			len += snprintf(sbuf + len, sizeof(sbuf) - len, "offset: %"PRIi64" ns", offset);
+			if (len > sizeof(sbuf)) len = sizeof(sbuf);
 
-		len += snprintf(sbuf + len, sizeof(sbuf) - len, ", ");
+			if (rtOpts->time_mode == TIME_BOTH) {
+				int64_t offset = ((int64_t)G_timeBothClock->offsetFromMaster.seconds * 1000000000)
+					+ (int64_t)G_timeBothClock->offsetFromMaster.nanoseconds;
 
-		if (!rtOpts->csvStats)
-			len += snprintf(sbuf + len, 
-					sizeof(sbuf) - len, "owd: ");
-        
+				len += snprintf(sbuf + len, sizeof(sbuf) - len, ", %s offset: %"PRIi64" ns",
+					(G_timeBothClock->name != NULL)? G_timeBothClock->name: "",
+					offset);
+				if (len > sizeof(sbuf)) len = sizeof(sbuf);
+			}
+		} else {
+			if (!rtOpts->csvStats) {
+				len += snprintf(sbuf + len, sizeof(sbuf) - len, "cid: ");
+				if (len > sizeof(sbuf)) len = sizeof(sbuf);
+			}
+			len += snprint_PortIdentity(sbuf + len, sizeof(sbuf) - len,
+				&ptpClock->parentPortIdentity, " ");
+			if (len > sizeof(sbuf)) len = sizeof(sbuf);
+
+      /*
+       * if grandmaster ID differs from parent port ID then
+       * also print GM ID
+       */
+      if (memcmp(ptpClock->grandmasterIdentity,
+                 ptpClock->parentPortIdentity.clockIdentity,
+                 CLOCK_IDENTITY_LENGTH)) {
+        len += snprint_ClockIdentity(sbuf + len, 
+					sizeof(sbuf) - len,
+                                     ptpClock->grandmasterIdentity, 
+				     " GM:");
+        if (len > sizeof(sbuf)) len = sizeof(sbuf);
+      }
+
+      len += snprintf(sbuf + len, sizeof(sbuf) - len, ", ");
+      if (len > sizeof(sbuf)) len = sizeof(sbuf);
+
+      if (!rtOpts->csvStats) {
+        len += snprintf(sbuf + len, 
+			sizeof(sbuf) - len, "owd: ");
+        if (len > sizeof(sbuf)) len = sizeof(sbuf);
+      }
+
 		if(rtOpts->delayMechanism == E2E) {
 			len += snprint_TimeInternal(sbuf + len, sizeof(sbuf) - len,
-						    &ptpClock->meanPathDelay);
+						&ptpClock->meanPathDelay);
 		} else {
 			len += snprint_TimeInternal(sbuf + len, sizeof(sbuf) - len,
 						    &ptpClock->peerMeanPathDelay);
 		}
 
+		if (len > sizeof(sbuf)) len = sizeof(sbuf);
 		len += snprintf(sbuf + len, sizeof(sbuf) - len, ", ");
+		if (len > sizeof(sbuf)) len = sizeof(sbuf);
 
-		if (!rtOpts->csvStats)
-			len += snprintf(sbuf + len, sizeof(sbuf) - len, 
+		if (!rtOpts->csvStats) {
+			len += snprintf(sbuf + len, sizeof(sbuf) - len,
 					"ofm: ");
+			if (len > sizeof(sbuf)) len = sizeof(sbuf);
+		}
 
 		len += snprint_TimeInternal(sbuf + len, sizeof(sbuf) - len,
-		    &ptpClock->offsetFromMaster);
+                                  &ptpClock->offsetFromMaster);
+		if (len > sizeof(sbuf)) len = sizeof(sbuf);
 
 
 
 		/* print MS and SM with sign */
 		len += snprintf(sbuf + len, sizeof(sbuf) - len, ", ");
-		if (!rtOpts->csvStats)
+		if (len > sizeof(sbuf)) len = sizeof(sbuf);
+		if (!rtOpts->csvStats) {
 			len += snprintf(sbuf + len, sizeof(sbuf) - len,
 			"stm: ");
-			
+		if (len > sizeof(sbuf)) len = sizeof(sbuf);
+		}
+
 		len += snprint_TimeInternal(sbuf + len, sizeof(sbuf) - len,
 				&(ptpClock->delaySM));
+		if (len > sizeof(sbuf)) len = sizeof(sbuf);
 
 		len += snprintf(sbuf + len, sizeof(sbuf) - len, ", ");
+		if (len > sizeof(sbuf)) len = sizeof(sbuf);
 
 
-		if (!rtOpts->csvStats)
+		if (!rtOpts->csvStats) {
 			len += snprintf(sbuf + len, sizeof(sbuf) - len,
 			"mts: ");
+			if (len > sizeof(sbuf)) len = sizeof(sbuf);
+		}
 
 		len += snprint_TimeInternal(sbuf + len, sizeof(sbuf) - len,
 				&(ptpClock->delayMS));
+		if (len > sizeof(sbuf)) len = sizeof(sbuf);
+
+
+		len += sprintf(sbuf + len, ", %s%Lf",
+                     rtOpts->csvStats ? "" : "drift: ",
+		     ptpClock->observed_drift);
+		if (len > sizeof(sbuf)) len = sizeof(sbuf);
 
 		
-		len += sprintf(sbuf + len, ", %s%d",
-		    rtOpts->csvStats ? "" : "drift: ", 
-			       ptpClock->observed_drift);
-
-
 
 
 		/* Last column has the type of last packet processed by the servo */
 		len += snprintf(sbuf + len, sizeof(sbuf) - len, ", ");
+		if (len > sizeof(sbuf)) len = sizeof(sbuf);
 
-		if (!rtOpts->csvStats)
-			len += snprintf(sbuf + len, sizeof(sbuf) - len,
-			"last_msg: ");
+      if (!rtOpts->csvStats) {
+        len += snprintf(sbuf + len, sizeof(sbuf) - len,
+	"last_msg: ");
+        if (len > sizeof(sbuf)) len = sizeof(sbuf);
+      }
 
-		len += snprintf(sbuf + len, sizeof(sbuf) - len,
-				"%c ", ptpClock->char_last_msg);
+      len += snprintf(sbuf + len, sizeof(sbuf) - len,
+		      "%c ", ptpClock->char_last_msg);
+      if (len > sizeof(sbuf)) len = sizeof(sbuf);
+    }
+  }
+  else {
+    if ((ptpClock->portState == PTP_MASTER) || (ptpClock->portState == PTP_PASSIVE)) {
 
-	}
-	else {
-		if ((ptpClock->portState == PTP_MASTER) || (ptpClock->portState == PTP_PASSIVE)) {
+      len += snprint_PortIdentity(sbuf + len, sizeof(sbuf) - len,
+                                  &ptpClock->parentPortIdentity, " ");
+      if (len > sizeof(sbuf)) len = sizeof(sbuf);
+    }
 
-			len += snprint_PortIdentity(sbuf + len, sizeof(sbuf) - len,
-				 &ptpClock->parentPortIdentity, " ");
-							 
-			//len += snprintf(sbuf + len, sizeof(sbuf) - len, ")");
-		}
 
-		
-		/* show the current reset number on the log */
-		if (ptpClock->portState == PTP_LISTENING) {
-			len += snprintf(sbuf + len,
-						     sizeof(sbuf) - len,
-						     " %d ", ptpClock->reset_count);
-		}
-	}
+    /* show the current reset number on the log */
+    if (ptpClock->portState == PTP_LISTENING) {
+      len += snprintf(sbuf + len,
+		      sizeof(sbuf) - len,
+                      " num_resets: %d ", ptpClock->reset_count);
+      if (len > sizeof(sbuf)) len = sizeof(sbuf);
+    }
+  }
 
-	
-	/* add final \n in normal status lines */
-	len += snprintf(sbuf + len, sizeof(sbuf) - len, "\n");
+
+  /* add final \n in normal status lines */
+  len += snprintf(sbuf + len, sizeof(sbuf) - len, "\n");
+  if (len > sizeof(sbuf)) len = sizeof(sbuf);
 
 #if 0   /* NOTE: Do we want this? */
 	if (rtOpts->nonDaemon) {
@@ -551,8 +681,8 @@
 		len += snprintf(sbuf + len, sizeof(sbuf) - len, "\n");
 	}
 #endif
-	write(1, sbuf, rtOpts->csvStats ? len : SCREEN_MAXSZ + 1);
-	
+	write(1, sbuf, len);
+
 }
 
 
@@ -581,6 +711,7 @@
 	return TRUE;
 }
 
+#if 0 /* Defined in dep/time.c - fetch time from hw */
 void 
 getTime(TimeInternal * time)
 {
@@ -600,21 +731,7 @@
 	time->nanoseconds = tp.tv_nsec;
 #endif /* linux || __APPLE__ */
 }
-
-void 
-setTime(TimeInternal * time)
-{
-	struct timeval tv;
- 
-	tv.tv_sec = time->seconds;
-	tv.tv_usec = time->nanoseconds / 1000;
-	WARNING("Going to step the system clock to %ds %dns\n",
-	       time->seconds, time->nanoseconds);
-	settimeofday(&tv, 0);
-	WARNING("Finished stepping the system clock to %ds %dns\n",
-	       time->seconds, time->nanoseconds);
-}
-
+#endif
 
 /* returns a double beween 0.0 and 1.0 */
 double 
@@ -627,44 +744,123 @@
 
 
 
-/*
- * TODO: this function should have been coded in a way to manipulate both the frequency and the tick,
- * to avoid having to call setTime() when the clock is very far away.
- * This would result in situations we would force the kernel clock to run the clock twice as slow,
- * in order to avoid stepping time backwards
- */
 #if !defined(__APPLE__)
-Boolean
-adjFreq(Integer32 adj)
+void
+setTimexFlags(int flags, Boolean quiet)
 {
-	struct timex t;
+	struct timex tmx;
+	int ret;
 
-	memset(&t, 0, sizeof(t));
-	if (adj > ADJ_FREQ_MAX){
-		adj = ADJ_FREQ_MAX;
-	} else if (adj < -ADJ_FREQ_MAX){
-		adj = -ADJ_FREQ_MAX;
+	memset(&tmx, 0, sizeof(tmx));
+
+	tmx.modes = MOD_STATUS;
+
+	tmx.status = getTimexFlags();
+	if(tmx.status == -1) 
+		return;
+	/* unset all read-only flags */
+	tmx.status &= ~STA_RONLY;
+	tmx.status |= flags;
+
+	ret = adjtimex(&tmx);
+
+	if (ret < 0)
+		PERROR("Could not set adjtimex flags: %s", strerror(errno));
+
+	if(!quiet && ret > 2) {
+		switch (ret) {
+		case TIME_OOP:
+			WARNING("Adjtimex: leap second already in progress\n");
+			break;
+		case TIME_WAIT:
+			WARNING("Adjtimex: leap second already occurred\n");
+			break;
+#if !defined(TIME_BAD)
+		case TIME_ERROR:
+#else
+		case TIME_BAD:
+#endif /* TIME_BAD */
+		default:
+			DBGV("unsetTimexFlags: adjtimex() returned TIME_BAD\n");
+			break;
+		}
+	}
+}
+
+void
+unsetTimexFlags(int flags, Boolean quiet) 
+{
+	struct timex tmx;
+	int ret;
+
+	memset(&tmx, 0, sizeof(tmx));
+
+	tmx.modes = MOD_STATUS;
+	tmx.status = getTimexFlags();
+	if(tmx.status == -1)
+		return;
+
+	/* unset all read-only flags */
+	tmx.status &= ~STA_RONLY;
+	tmx.status &= ~flags;
+
+	ret = adjtimex(&tmx);
+
+	if (ret < 0)
+		PERROR("Could not unset adjtimex flags: %s", strerror(errno));
+
+	if(!quiet && ret > 2) {
+		switch (ret) {
+		case TIME_OOP:
+			WARNING("Adjtimex: leap second already in progress\n");
+			break;
+		case TIME_WAIT:
+			WARNING("Adjtimex: leap second already occurred\n");
+			break;
+#if !defined(TIME_BAD)
+		case TIME_ERROR:
+#else
+		case TIME_BAD:
+#endif /* TIME_BAD */
+		default:
+			DBGV("unsetTimexFlags: adjtimex() returned TIME_BAD\n");
+			break;
+		}
+	}
+}
+
+int getTimexFlags(void)
+{
+	struct timex tmx;
+	int ret;
+
+	memset(&tmx, 0, sizeof(tmx));
+
+	tmx.modes = 0;
+	ret = adjtimex(&tmx);
+	if (ret < 0) {
+		PERROR("Could not read adjtimex flags: %s", strerror(errno));
+		return(-1);
+
 	}
 
-	t.modes = MOD_FREQUENCY;
-	t.freq = adj * ((1 << 16) / 1000);
+	return( tmx.status );
+}
 
-	/* do calculation in double precision, instead of Integer32 */
-	int t1 = t.freq;
-	int t2;
-	
-	float f = (adj + 0.0) * (((1 << 16) + 0.0) / 1000.0);  /* could be float f = adj * 65.536 */
-	t2 = t1;  // just to avoid compiler warning
-	t2 = (int)round(f);
-	t.freq = t2;
+Boolean
+checkTimexFlags(int flags) {
 
-	DBG2("        adj is %d;  t freq is %d       (float: %f Integer32: %d)\n", adj, t.freq,  f, t1);
-	
-	return !adjtimex(&t);
+    int tflags = getTimexFlags();
+    if (tflags == -1) 
+	    return FALSE;
+    return ((tflags & flags) == flags);
 }
 
 #else
 
+/* @ioctl_timestamping TODO This won't work - not sure whether we can easily support
+* apple and ioctl timestamping */
+
 void
 adjTime(Integer32 nanoseconds)
 {
